#ifndef _HASH_H
#define _HASH_H

#include<LEDA/graph.h>

typedef struct symbol_s {
    char *name;
    edge info;
} Hash_Entry;


typedef struct {
	int S;
	int n_hashed;
	void *Hash_tab;
} Hash_Info;


extern Hash_Entry *Hash_Insert(char *, Hash_Info *);
extern Hash_Entry *Hash_Find(char *, Hash_Info *);
extern void Init_Hash_Scan(Hash_Info *);
extern Hash_Entry *Next_Hash_Entry();
extern void Apply_To_Hash(void (*)(), Hash_Info *);
extern void Apply_To_Hash_Direct(void (*)(), Hash_Info *);
extern Hash_Info *Init_Hash();

#endif /* _HASH_H */

